// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services'])

.run(function($ionicPlatform) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }
  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

    $ionicConfigProvider.form.toggle('large');
    $ionicConfigProvider.tabs.position('bottom');
    $ionicConfigProvider.tabs.style('standard');
    $ionicConfigProvider.navBar.alignTitle('center');
//    $ionicConfigProvider.views.forwardCache(true);
//    $ionicConfigProvider.views.maxCache(30);
    $ionicConfigProvider.views.maxCache(0);
    $ionicConfigProvider.views.transition('none');
    
    
  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

.state('intro', {
    url: '/intro',
    templateUrl: 'templates/intro.html',
    controller: 'labController as lab'
}) 
  
  // setup an abstract state for the tabs directive
.state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html'
  })

  // Each tab has its own nav history stack:

  .state('tab.settings', {
    url: '/settings',
      cache: false,
    views: {
      'tab-settings': {
        templateUrl: 'templates/tab-settings.html',
        controller: 'settingsController as set'
//        controllerAs: 'settings'
      }
    }
  })

  .state('tab.app', {
      url: '/app',
      views: {
        'tab-app': {
            templateUrl: 'templates/tab-app.html',
            controller: 'appController as app'
//            controllerAs: 'app'
        }
      }
    })

  .state('tab.lab', {
    url: '/lab',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab.html',
        controller: 'labController as lab'
//        controllerAs: 'lab'
      }
    }
  })
  
  
  .state('tab.lab-logvar', {
    url: '/lab-logvar',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-logvar.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-logoperator', {
    url: '/lab-logoperator',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-logoperator.html',
        controller: 'labController as lab'
      }
    }
  })  
  .state('tab.lab-logfunction1', {
    url: '/lab-logfunction1',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-logfunction1.html',
        controller: 'labController as lab'
      }
    }
  })  
  .state('tab.lab-logfunction2', {
    url: '/lab-logfunction2',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-logfunction2.html',
        controller: 'labController as lab'
      }
    }
  })  
  .state('tab.lab-flipflop', {
    url: '/lab-flipflop',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-flipflop.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-flipflop-sync', {
    url: '/lab-flipflop-sync',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-flipflop-sync.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-boolean-alg', {
    url: '/lab-boolean-alg',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-boolean-alg.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-waveform1', {
    url: '/lab-waveform1',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-waveform1.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-example1', {
    url: '/lab-example1',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-example1.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-example2', {
    url: '/lab-example2',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-example2.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-example3', {
    url: '/lab-example3',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-example3.html',
        controller: 'labController as lab'
      }
    }
  })
  .state('tab.lab-example4', {
    url: '/lab-example4',
    views: {
      'tab-lab': {
        templateUrl: 'templates/tab-lab-example4.html',
        controller: 'labController as lab'
      }
    }
  })
  
  
  ;

  // if none of the above states are matched, use this as the fallback
//  $urlRouterProvider.otherwise('/tab/lab');
    $urlRouterProvider.otherwise('/intro');

});
