angular.module('starter.controllers', [])


.directive('logChartX', function(){
    return {
        scope: {
            inp: '=',
            color: '@'
        },
        replace: true,

        templateNamespace: 'svg',
        link: function($scope){
            
            $scope.color = $scope.color || "black";
            
            $scope.getPath = function(){
                $scope.Path1 = "M 20 30";
                if ($scope.inp.length) {
                    $scope.Path1 += $scope.inp[0] ? "m 0, -20, h 20" : "h 20";
                };
                
                for (var i = 1; i<$scope.inp.length; i++){
                    if ($scope.inp[i]<$scope.inp[i-1]) {$scope.Path1 += "m 0 20"} 
                    else if ($scope.inp[i]>$scope.inp[i-1]) {$scope.Path1 += "m 0 -20"};
                $scope.Path1 += "h 20";

                };
                $scope.Path1 += "Z";                
                
                return $scope.Path1;
            };
            


        },
        template: function(scope){
            return '<path d="{{getPath()}}" stroke="{{color}}" stroke-width="3">'
        }
    }
})


.directive('logChartY', function(){
    return {
        scope: {
            inp: '=',
            color: '@'
        },
        replace: true,

        templateNamespace: 'svg',
        link: function($scope){
            
            $scope.color = $scope.color || "black";
            
            $scope.getPath = function(){
                $scope.Path2 = "M 20 30";
                $scope.Path2 += $scope.inp[0] ? "m 0, -20" : "";
                for (var i = 1; i<$scope.inp.length; i++){                  
                $scope.Path2 += "m 20, 0";
                if ($scope.inp[i]<$scope.inp[i-1]) {$scope.Path2 += "v 0 20"}
                else if ($scope.inp[i]>$scope.inp[i-1]) {$scope.Path2 += "v 0 -20"}
                };

                $scope.Path2 += "Z";
                
                return $scope.Path2;
            };
            

        },
        template: function(scope){
            return '<path d="{{getPath()}}" stroke="{{color}}" stroke-width="3">'
        }
    }
})

// example OR 2 
.directive('logOr2', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            a: '=',
            b: '=',
            out: '=',
            hl: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;

            $scope.sign = "\u2265"+"1";
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();

            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            
            $scope.Q = function(){
                if ($scope.a === undefined || $scope.a === null || $scope.b === undefined || $scope.b === null ) return null;
                var res = $scope.a || $scope.b;
                $scope.out = res;
                return res;
            };

        },
        template: '<g stroke="black" transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(a)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50"  stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(b)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<line x1="80" y1="35" x2="110" y2="35" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(Q())}}</text>' + 
                '</g>'
    }
})

// example NOR 2 
.directive('logNor2', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            a: '=',
            b: '=',
            out: '=',
            hl: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;

            $scope.sign = "\u2265"+"1";
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            
            $scope.Q = function(){
                if ($scope.a === undefined || $scope.a === null || $scope.b === undefined || $scope.b === null ) return null;
                var res = !($scope.a || $scope.b);
                $scope.out = res;
                return res;
            };

        },
        template: '<g stroke="black" transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(a)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50"  stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(b)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<circle cx="85" cy="35" r=5 stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="35" x2="110" y2="35" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(Q())}}</text>' + 
                '</g>'
    }
})

// example AND 2 
.directive('logAnd2', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            a: '=',
            b: '=',
            out: '=',
            hl: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;

            $scope.sign = "&";
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            
            $scope.Q = function(){
                if ($scope.a === undefined || $scope.a === null || $scope.b === undefined || $scope.b === null ) return null;
                var res = $scope.a && $scope.b;
                $scope.out = res;
                return res;
            };

        },
        template: '<g stroke="black" transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(a)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50"  stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(b)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<line x1="80" y1="35" x2="110" y2="35" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(Q())}}</text>' + 
                '</g>'
    }
})

// example NAND 2 
.directive('logNand2', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            a: '=',
            b: '=',
            out: '=',
            hl: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;

            $scope.sign = "&";
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            
            $scope.Q = function(){
                if ($scope.a === undefined || $scope.a === null || $scope.b === undefined || $scope.b === null ) return null;
                var res = !($scope.a && $scope.b);
                $scope.out = res;
                return res;
            };

        },
        template: '<g stroke="black" transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(a)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50"  stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(b)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<circle cx="85" cy="35" r=5 stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="35" x2="110" y2="35" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(Q())}}</text>' + 
                '</g>'
    }
})

// example XOR 2 
.directive('logXor2', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            a: '=',
            b: '=',
            out: '=',
            hl: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;

            $scope.sign = "=1";
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            
            $scope.Q = function(){
                if ($scope.a === undefined || $scope.a === null || $scope.b === undefined || $scope.b === null ) return null;
                var res = $scope.a !== $scope.b;
                $scope.out = res;
                return res;
            };

        },
        template: '<g stroke="black" transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(a)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50"  stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(b)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<line x1="80" y1="35" x2="110" y2="35" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(Q())}}</text>' + 
                '</g>'
    }
})

// example XNOR 2 
.directive('logXnor2', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            a: '=',
            b: '=',
            out: '=',
            hl :'='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;

            $scope.sign = "=1";
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            
            $scope.Q = function(){
                if ($scope.a === undefined || $scope.a === null || $scope.b === undefined || $scope.b === null ) return null;
                var res = !($scope.a !== $scope.b);
                $scope.out = res;
                return res;
            };

        },
        template: '<g stroke="black" transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(a)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50"  stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(b)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<circle cx="85" cy="35" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="35" x2="110" y2="35" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(Q())}}</text>' + 
                '</g>'
    }
})

// example SR async 
.directive('logSr', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            s: '=',
            r: '=',
            out: '=',
            hl: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.last = false;

            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.setLast = function(S, R){
                if (!S && !R) {return;};
                if (S) return $scope.last = S;
                if (R) return $scope.last = !R;
                return false;
                
            };
            $scope.Q = function(){
                var res;
                
                if ($scope.s === undefined || $scope.s === null || $scope.r === undefined || $scope.r === null ) return null;
                
                $scope.setLast($scope.s, $scope.r);
                
                if (!$scope.s && !$scope.r) res = $scope.last;
                if ($scope.s && !$scope.r) res = true;
                if (!$scope.s && $scope.r) res = false;
                if ($scope.s && $scope.r) res = '?';
                $scope.out = res;
                return res;
            };
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            $scope.strLog_SR = function(value){

                $scope.setLast($scope.s, $scope.r);
                if ($scope.s && $scope.r) return '?';
                return value ? $scope.H : $scope.L;
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(s)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(r)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">S</text>' + 
                    '<text x="45" y="55">R</text>' + 
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog_SR(Q())}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog_SR(!Q())}}</text>' + 
                '</g>'
    }
})


// example JK async 
.directive('logJk', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            j: '=',
            k: '=',
            out: '=',
            hl: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.last = null;
            
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.Q = false;
            
            $scope.F = function(J, K, last){                
                
//                if (J && K) {$scope.last = $scope.Q; $scope.Q = !$scope.last;};
                if (J && K) {$scope.last = $scope.Q; $scope.Q = !$scope.Q;};
                if (J && !K) {$scope.last = $scope.Q; $scope.Q = true;};

                if (!J && !K) {};
                if (K && !J) {$scope.last = $scope.Q; $scope.Q = false;};
                $scope.out = $scope.Q;
            };
            
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };

            $scope.$watchGroup(['j', 'k'], function(){
                $scope.F($scope.j, $scope.k, $scope.last);
            });
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(j)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(k)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">J</text>' + 
                    '<text x="45" y="55">K</text>' + 
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog(Q)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog(!Q)}}</text>' + 
                '</g>'
    }
})

// example SRT sync 
.directive('logSrt', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            s: '=',
            r: '=',
            t: '=',
            out: '=',
            hl: '=',
            tc: '@'
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            
            $scope.tc = $scope.tc || 'T';
            
            $scope.last = false;

            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.setLast = function(S, R){
                if (!S && !R) {return;};
                if (S) return $scope.last = S;
                if (R) return $scope.last = !R;
                return false;
                
            };
            $scope.Q = function(){
                var res;
                
                if ($scope.s === undefined || $scope.s === null || $scope.r === undefined || $scope.r === null ) return null;
                
                if (!$scope.t) return $scope.last;
                
                $scope.setLast($scope.s, $scope.r);
                
                if (!$scope.s && !$scope.r) res = $scope.last;
                if ($scope.s && !$scope.r) res = true;
                if (!$scope.s && $scope.r) res = false;
                if ($scope.s && $scope.r) res = '?';
                $scope.out = res;
                return res;
            };
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            $scope.strLog_SR_Q = function(value){
                if (!$scope.t) return $scope.strLog($scope.last);
                $scope.setLast($scope.s, $scope.r);
                if ($scope.s && $scope.r) return '?';
                return value ? $scope.H : $scope.L;
            };
            $scope.strLog_SR_negQ = function(value){
                if (!$scope.t) return $scope.strLog(!$scope.last);
                $scope.setLast($scope.s, $scope.r);
                if ($scope.s && $scope.r) return '?';
                return value ? $scope.H : $scope.L;
            };
            
            
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(s)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(r)}}</text>' + 
        
                    '<line x1="10" y1="35" x2="40" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="32">{{strLog(t)}}</text>' +         
        
        
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">S</text>' + 
                    '<text x="45" y="55">R</text>' + 
        
                    '<text x="45" y="40">{{tc}}</text>' + 
        
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog_SR_Q(Q())}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog_SR_negQ(!Q())}}</text>' + 
                '</g>'
    }
})

// example JKT sync 
.directive('logJkt', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            j: '=',
            k: '=',
            t: '=',
            out: '=',
            hl: '=',
            tc: '@'
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.last = null;
            
            $scope.tc = $scope.tc || 'T';

            
            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.Q = false;
//            $scope.out = false;
            
            $scope.F = function(J, K, T, last){                
                if (!T) return;
//                if (J && K) {$scope.last = $scope.Q; $scope.Q = !$scope.last;};
                if (J && K) {$scope.last = $scope.Q; $scope.Q = !$scope.Q;};
                if (J && !K) {$scope.last = $scope.Q; $scope.Q = true;};

                if (!J && !K) {};
                if (K && !J) {$scope.last = $scope.Q; $scope.Q = false;};
                $scope.out = $scope.Q;
            };
            
            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };

            $scope.$watchGroup(['j', 'k', 't'], function(){
                $scope.F($scope.j, $scope.k, $scope.t, $scope.last);
            });
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(j)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(k)}}</text>' + 
        
                    '<line x1="10" y1="35" x2="40" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="32">{{strLog(t)}}</text>' +         
        
        
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">J</text>' + 
                    '<text x="45" y="55">K</text>' + 
        
                    '<text x="45" y="40">{{tc}}</text>' + 
        
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog(Q)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog(!Q)}}</text>' + 
                '</g>'
    }
})

// example D sync 
.directive('logD', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            d: '=',
            t: '=',
            out: '=',
            hl: '=',
            tc: '@'
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            
            $scope.tc = $scope.tc || 'T';

            $scope.setHL = function(){
                if ($scope.hl === '1, 0') {
                    $scope.H = 1;
                    $scope.L = 0;
                    return;
                };
                if ($scope.hl === 'H, L') {
                    $scope.H = 'H';
                    $scope.L = 'L';
                    return;
                };            
                if ($scope.hl === 'T, F') {
                    $scope.H = 'T';
                    $scope.L = 'F';
                    return;
                };
            
            }();
            
            $scope.Q = false;
            $scope.out = false;
            
            $scope.F = function(D, T){
                if (!T) return;
                $scope.Q = D;
                $scope.out = $scope.Q;
            };

            $scope.strLog = function(value){
                if (value === undefined || value === null) return null;
                return value ? $scope.H : $scope.L;
            };
            
            $scope.$watchGroup(['d', 't'], function(){
                $scope.F($scope.d, $scope.t);
            });

        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(d)}}</text>' + 

        
                    '<line x1="10" y1="35" x2="40" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="32">{{strLog(t)}}</text>' + 
        
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">D</text>' + 

        
                    '<text x="45" y="40">{{tc}}</text>' + 
        
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog(Q)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog(!Q)}}</text>' + 
                '</g>'
    }
})


//-- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- -->
//-- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- --- -->

.directive('schR', function(){
    return {
        scope: {
            x: '=',
            y: '='
        },
        replace: true,
        templateNamespace: 'svg',
        template: '<g transform="translate({{x}}, {{y}})">' + 
                    '<line x1="0" y1="20" x2="20" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<rect x="20" y="10" width="60" height="20" stroke="black" fill="none" stroke-width="2" />' + 
                    '<line x1="80" y1="20" x2="100" y2="20" stroke="black" stroke-width="2"/>' + 
                '</g>'
    }
})

.directive('schLed', function(){
    return {
        scope: {
            x: '=',
            y: '=',
            on: '='
        },
        replace: true,
        templateNamespace: 'svg',
        controller: function($scope){
            if ($scope.on) $scope.fill = 'yellow';
            else $scope.fill = 'none';
            
            $scope.$watch('on', function(){
                if ($scope.on) $scope.fill = 'yellow';
                else $scope.fill = 'none';               
            })
        },
        template: '<g transform="translate({{x}}, {{y}})">' + 
                    '<line x1="0" y1="40" x2="80" y2="40" stroke="black" stroke-width="2"/>' + 
                    '<polyline points="20, 20 20, 60 60, 40 20, 20" fill="none" stroke="black" stroke-width="2" />' + 
                    '<g transform="translate(15, 5) rotate(-45, 25, 20)">' + 
                    '<line x1="25" y1="20" x2="45" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<line x1="45" y1="20" x2="35" y2="15" stroke="black" stroke-width="2"/>' + 
                    '<line x1="45" y1="20" x2="35" y2="25" stroke="black" stroke-width="2"/>' + 
                    '</g>' + 
                    '<g transform="translate(15, 5) rotate(-45, 25, 20) translate(-5, -15)">' + 
                    '<line x1="25" y1="20" x2="45" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<line x1="45" y1="20" x2="35" y2="15" stroke="black" stroke-width="2"/>' + 
                    '<line x1="45" y1="20" x2="35" y2="25" stroke="black" stroke-width="2"/>' + 
                    '</g>' +        
                    '<line x1="60" y1="20" x2="60" y2="60" stroke="black" stroke-width="2"/>' + 
                    '<circle cx="40" cy="40" r="40" fill="{{fill}}" fill-opacity="0.6" />' +
                    
                '</g>'
    }
})

.directive('schGround', function(){
    return {
        scope: {
            x: '=',
            y: '='
        },
        replace: true,
        templateNamespace: 'svg',
        template: '<g transform="translate({{x}}, {{y}})">' + 
                    '<line x1="20" y1="5" x2="20" y2="45" stroke="black" stroke-width="2"/>' + 
                    '<line x1="0" y1="45" x2="40" y2="45" stroke="black" stroke-width="2"/>' + 
                    '<line x1="5" y1="50" x2="35" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<line x1="10" y1="55" x2="30" y2="55" stroke="black" stroke-width="2"/>' + 
                '</g>'
    }
})

// D sync 
.directive('gateD', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=',
            clock: '@'
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.lastQ = false;
            $scope.clock = $scope.clock || 'T';
            
            $scope.Q = false;
            
            $scope.F = function(D, T){
                if (!T) return;
                $scope.Q = D;
            };

            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
            
            $scope.$watchGroup(['inp1', 'inp2'], function(){
                $scope.F($scope.inp1, $scope.inp2);
            });

        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 

        
                    '<line x1="10" y1="35" x2="40" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="32">{{strLog(inp2)}}</text>' + 
        
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">D</text>' + 

        
                    '<text x="45" y="40">{{clock}}</text>' + 
        
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog(Q)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog(!Q)}}</text>' + 
                '</g>'
    }
})



// JKT sync 
.directive('gateJkt', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=',
            inp3: '=',
            clock: '@'
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.lastQ = false;
            $scope.clock = $scope.clock || 'T';
            
            $scope.Q = false;
            
            $scope.F = function(J, K, T, lastQ){
                if (!T) return;
                
                if (J && K) {$scope.lastQ = $scope.Q; $scope.Q = !$scope.lastQ;};
                if (J && !K) {$scope.lastQ = $scope.Q; $scope.Q = true;};

                if (!J && !K) {};
                if (K && !J) {$scope.lastQ = $scope.Q; $scope.Q = false;};
            };

            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
            
            $scope.$watchGroup(['inp1', 'inp2', 'inp3'], function(){
                $scope.F($scope.inp1, $scope.inp2, $scope.inp3, $scope.lastQ);
            });

        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
        
                    '<line x1="10" y1="35" x2="40" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="32">{{strLog(inp3)}}</text>' + 
        
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">J</text>' + 
                    '<text x="45" y="55">K</text>' + 
        
                    '<text x="45" y="40">{{clock}}</text>' + 
        
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog(Q)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog(!Q)}}</text>' + 
                '</g>'
    }
})



// SRT sync 
.directive('gateSrt', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=',
            inp3: '=',
            clock: '@'
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.clock = $scope.clock || 'T';
            $scope.last = false;

            
            $scope.setLast = function(S, R){
                if (!S && !R) {return;};
                $scope.last = $LogFunctions.logSR_Q($scope.inp1, $scope.inp2, $scope.last);
            };
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
            $scope.strLog_SRT_Q = function(S, R, T, last){
                if (!T) return $scope.strLog(last);
                $scope.setLast(S, R);
                return $Format.strLog_SR_Q(S, R, last);
            };
            $scope.strLog_SRT_negQ = function(S, R, T, last){
                if (!T) return $scope.strLog(!last);
                return $Format.strLog_SR_negQ(S, R, last);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
        
                    '<line x1="10" y1="35" x2="40" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="32">{{strLog(inp3)}}</text>' +         
        
        
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">S</text>' + 
                    '<text x="45" y="55">R</text>' + 
        
                    '<text x="45" y="40">{{clock}}</text>' + 
        
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog_SRT_Q(inp1, inp2, inp3, last)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog_SRT_negQ(inp1, inp2, inp3, last)}}</text>' + 
                '</g>'
    }
})


// JK async 
.directive('gateJk', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '='
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
//            $scope.lastQ = false;
            $scope.lastQ = null;
            
            $scope.Q = false;
            
            $scope.F = function(J, K, lastQ){
//                if (J && K) {$scope.lastQ = $scope.Q; $scope.Q = !$scope.lastQ;};
                if (J && K) {$scope.lastQ = $scope.Q; $scope.Q = !$scope.Q;};
                if (J && !K) {$scope.lastQ = $scope.Q; $scope.Q = true;};

                if (!J && !K) {};
                if (K && !J) {$scope.lastQ = $scope.Q; $scope.Q = false;};
            };

            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
            
            $scope.$watchGroup(['inp1', 'inp2'], function(){
                $scope.F($scope.inp1, $scope.inp2, $scope.lastQ);
            });

        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">J</text>' + 
                    '<text x="45" y="55">K</text>' + 
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog(Q)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog(!Q)}}</text>' + 
                '</g>'
    }
})

// SR async 
.directive('gateSr', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=' 
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.last = false;
            $scope.sign = "\u2265"+"1";
            
            $scope.setLast = function(S, R){
                if (!S && !R) {return;};
                $scope.last = $LogFunctions.logSR_Q($scope.inp1, $scope.inp2, $scope.last);
            };
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
            $scope.strLog_SR_Q = function(S, R, last){
                $scope.setLast(S, R);
                return $Format.strLog_SR_Q(S, R, last);
            };
            $scope.strLog_SR_negQ = function(S, R, last){
                return $Format.strLog_SR_negQ(S, R, last);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="45" y="25">S</text>' + 
                    '<text x="45" y="55">R</text>' + 
                    '<line x1="80" y1="20" x2="110" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="17">{{strLog_SR_Q(inp1, inp2, last)}}</text>' + 
                    '<circle cx="85" cy="50" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="50" x2="110" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="65" y="25">Q</text>' + 
                    '<line x1="65" y1="40" x2="75" y2="40" stroke="black" stroke-width="1"/>' + 
                    '<text x="65" y="55">Q</text>' + 
                    '<text x="100" y="47">{{strLog_SR_negQ(inp1, inp2, last)}}</text>' + 
                '</g>'
    }
})

// OR 2 
.directive('gateOr2', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=' 
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.sign = "\u2265"+"1";
            $scope.F = function(){
                return $LogFunctions.logOR_2($scope.inp1, $scope.inp2);
            };
//            $scope.$watchGroup(['inp1', 'inp2'], function() {
//                $scope.F = $LogFunctions.logOR_2($scope.inp1, $scope.inp2);
//            });
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke="black" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<line x1="80" y1="35" x2="110" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(F())}}</text>' + 
                '</g>'
    }
})


// NOR 2 
.directive('gateNor2', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=' 
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.sign = "\u2265"+"1";
            $scope.F = function(){
                return $LogFunctions.logNOR_2($scope.inp1, $scope.inp2);
            };
//            $scope.$watchGroup(['inp1', 'inp2'], function() {
//                $scope.F = $LogFunctions.logNOR_2($scope.inp1, $scope.inp2);
//            });
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke="black" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<circle cx="85" cy="35" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="35" x2="110" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(F())}}</text>' + 
                '</g>'
    }
})


// AND 2 
.directive('gateAnd2', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=' 
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.sign = "&";
            $scope.F = function(){
                return $LogFunctions.logAND_2($scope.inp1, $scope.inp2);
            };
//            $scope.$watchGroup(['inp1', 'inp2'], function() {
//                $scope.F = $LogFunctions.logAND_2($scope.inp1, $scope.inp2);
//            });
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke="black" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<line x1="80" y1="35" x2="110" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(F())}}</text>' + 
                '</g>'
    }
})


// NAND 2 
.directive('gateNand2', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=' 
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.sign = "&";
            $scope.F = function(){
                return $LogFunctions.logNAND_2($scope.inp1, $scope.inp2);
            };
//            $scope.$watchGroup(['inp1', 'inp2'], function() {
//                $scope.F = $LogFunctions.logNAND_2($scope.inp1, $scope.inp2);
//            });
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke="black" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<circle cx="85" cy="35" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="35" x2="110" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(F())}}</text>' + 
                '</g>'
    }
})


// XOR 2 
.directive('gateXor2', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=' 
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.sign = "=1";
            $scope.F = function(){
                return $LogFunctions.logXOR_2($scope.inp1, $scope.inp2);
            };
//           $scope.$watchGroup(['inp1', 'inp2'], function() {
//                $scope.F = $LogFunctions.logXOR_2($scope.inp1, $scope.inp2);
//            });
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke="black" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<line x1="80" y1="35" x2="110" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(F())}}</text>' + 
                '</g>'
    }
})


// XNOR 2 
.directive('gateXnor2', function($LogFunctions, $Format){
    return {
        scope: {
            x: '=',
            y: '=',
            inp1: '=',
            inp2: '=' 
        },
        replace: true,
        templateNamespace: 'svg',
        link: function($scope){
            $scope.x = $scope.x || 0;
            $scope.y = $scope.y || 0;
            $scope.sign = "=1";
            $scope.F = function(){
                return $LogFunctions.logXNOR_2($scope.inp1, $scope.inp2);
            };
//            $scope.F = $LogFunctions.logXNOR_2($scope.inp1, $scope.inp2);
//            $scope.$watchGroup(['inp1', 'inp2'], function() {
//                $scope.F = $LogFunctions.logXNOR_2($scope.inp1, $scope.inp2);
//            });
            $scope.strLog = function(value){
                return $Format.strLog(value);
            };
        },
        template: '<g transform="translate({{x}}, {{y}})">'+
                    '<line x1="10" y1="20" x2="40" y2="20" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="17">{{strLog(inp1)}}</text>' + 
                    '<line x1="10" y1="50" x2="40" y2="50" stroke="black" stroke-width="2"/>' + 
                    '<text x="10" y="47">{{strLog(inp2)}}</text>' + 
                    '<rect x="40" y="5" width="40" height="60" stroke="black" fill="none" stroke-width="2" />' + 
                    '<text x="75" y="25" stroke="black" stroke-width="1.5" font-size="1.2em" text-anchor="end">{{sign}}</text>' + 
                    '<circle cx="85" cy="35" r=5 stroke="black" stroke-width="2" fill="none" />' + 
                    '<line x1="90" y1="35" x2="110" y2="35" stroke="black" stroke-width="2"/>' + 
                    '<text x="100" y="32">{{strLog(F())}}</text>' + 
                '</g>'
    }
})


.controller('globalController', function($Settings){

    this.Zoom = $Settings.settings.app.getZoom();

})

.controller('settingsController', function($Settings, $Lang) {
    
    
    this.L = {};
    
    this.Lang_EN = {};
    this.Lang_ES = {};
    this.Lang_CZ = {};
    this.Lang_PT = {};
    this.Lang_FR = {};
    
    this.Lang_EN = {
        _100: '',
        _101: '',
        _102: '',
        _103: '',
        _104: '',
        _105: '',
        _106: '',
        _107: '',
        _108: 'Settings',
        _109: '',
        _110: 'Language',
        _111: 'Logic values',
        _112: 'Logic function',
        _113: 'Clock pulse (sync.)',
        _114: 'Background color',
        _115: 'Zoom',
        _116: '',
        _117: '',
        _118: '',
        _119: '',
        _120: '',
        _121: '',
        _122: ''

    };
    this.Lang_ES = {
        _100: '',
        _101: '',
        _102: '',
        _103: '',
        _104: '',
        _105: '',
        _106: '',
        _107: '',
        _108: 'Ajustes',
        _109: '',
        _110: 'Idioma',
        _111: 'Valores lógicos',
        _112: 'Función lógica',
        _113: 'Pulso de reloj (síncr.)',
        _114: 'Color de fondo',
        _115: 'Zoom',
        _116: '',
        _117: '',
        _118: '',
        _119: '',
        _120: '',
        _121: '',
        _122: ''

    };
    this.Lang_CZ = {
        _100: '',
        _101: '',
        _102: '',
        _103: '',
        _104: '',
        _105: '',
        _106: '',
        _107: '',
        _108: 'Nastavení',
        _109: '',
        _110: 'Jazyk',
        _111: 'Logické hodnoty',
        _112: 'Logická funkce',
        _113: 'Hodinový impuls (synchr.)',
        _114: 'Barva pozadí',
        _115: 'Lupa (měřítko)',
        _116: '',
        _117: '',
        _118: '',
        _119: '',
        _120: '',
        _121: '',
        _122: ''

    };    
    this.Lang_PT = {
        _100: '',
        _101: '',
        _102: '',
        _103: '',
        _104: '',
        _105: '',
        _106: '',
        _107: '',
        _108: 'Definições',
        _109: '',
        _110: 'Idioma',
        _111: 'Valores lógicos',
        _112: 'Função lógica',
        _113: 'Pulso de clock (sínc.)',
        _114: 'Cor de fundo',
        _115: 'Zoom',
        _116: '',
        _117: '',
        _118: '',
        _119: '',
        _120: '',
        _121: '',
        _122: ''

    };     

    this.Lang_FR = {
        _100: '',
        _101: '',
        _102: '',
        _103: '',
        _104: '',
        _105: '',
        _106: '',
        _107: '',
        _108: 'Paramètres',
        _109: '',
        _110: 'Langue',
        _111: 'Valeurs logiques',
        _112: 'Fonction logique',
        _113: 'Impulsion d\'horloge',
        _114: 'Couleur d\'arrière plan',
        _115: 'Zoom',
        _116: '',
        _117: '',
        _118: '',
        _119: '',
        _120: '',
        _121: '',
        _122: ''

    };
    
    
    this.getActive = function(){
        return $Lang.getActive();
    };
    
    if (this.getActive() === 'EN') this.L = this.Lang_EN;
    if (this.getActive() === 'ES') this.L = this.Lang_ES;
    if (this.getActive() === 'CZ') this.L = this.Lang_CZ;
    if (this.getActive() === 'PT') this.L = this.Lang_PT;
    if (this.getActive() === 'FR') this.L = this.Lang_FR;
    
    this.getActive = function(){
        return $Lang.getActive();
    };
    this.setActive = function(value){
        $Lang.setActive(value).then(function(){
            if (this.getActive() === 'EN') this.L = this.Lang_EN;
            if (this.getActive() === 'ES') this.L = this.Lang_ES;
            if (this.getActive() === 'CZ') this.L = this.Lang_CZ;        
            if (this.getActive() === 'PT') this.L = this.Lang_PT;
            if (this.getActive() === 'FR') this.L = this.Lang_FR;        
        });
        
    };
    

    this.background = function(){
        return $Settings.settings.app.getBackgroundTabSet();
    };
    
    this.HighLow = function(){
        return $Settings.settings.app.getHighLow();
    };
    
    this.strLogF = function(){
        return $Settings.settings.app.getLogFunction();
    };
    
    this.Zoom = $Settings.settings.app.getZoom();

    
//    this.settings = $Settings.settings.app;
    
    this.bgLab = $Settings.settings.app.getBackgroundTabLab();
    this.bgSet = $Settings.settings.app.getBackgroundTabSet();
    this.bgApp = $Settings.settings.app.getBackgroundTabApp();
    
    
    this.setBgLab = function(value){
        $Settings.settings.app.setBackgroundTabLab(value);
        this.bgLab = $Settings.settings.app.getBackgroundTabLab();
    };
    
    this.setBgSet = function(value){
        $Settings.settings.app.setBackgroundTabSet(value);
        this.bgSet = $Settings.settings.app.getBackgroundTabSet();
    }; 
    
    this.setBgApp = function(value){
        $Settings.settings.app.setBackgroundTabApp(value);
        this.bgApp = $Settings.settings.app.getBackgroundTabApp();
    }; 
    
    this.setHighLow = function(value){
        $Settings.settings.app.setHighLow(value);
    };
    
    this.setStrLogF = function(value){
        $Settings.settings.app.setLogFunction(value);
    };
    
    this.setZoom = function(value){
        $Settings.settings.app.setZoom(value);
    };
    
    this.TimeSignal = function(){
        return $Settings.settings.app.getTimeSignal();
    };
    this.setTimeSignal = function(value){
        $Settings.settings.app.setTimeSignal(value);
    };
    
})

.controller('appController', function($Settings, $Lang, $interval) {
    this.logArr = [];
     
    
    this.addValue=function(value){
        this.logArr.push(value);
        if (this.logArr.length == 14){this.logArr.splice(0, 1);};
    };
    
    this.addValueTime = function(){
        var d = new Date();
        var n = d.getMilliseconds();
        this.addValue(n % 2);
    };

    
    $interval(function(){
        console.log("$interval");
        this.addValueTime();
    }, 501);
    
    this.Zoom = function(){
        return $Settings.settings.app.getZoom();
    };
    this.data = $Settings.data;

    this.background = function(){
        return $Settings.settings.app.getBackgroundTabApp();
    };
    
    this.A = null;
    this.B = null;
    this.Q = null;
    
    this.Lang_EN = {
    _200: 'Application'
    };
    this.Lang_ES = {
    _200: 'Aplicación'
    };
    this.Lang_CZ = {
    _200: 'Aplikace'
    };
    this.Lang_PT = {
    _200: 'Aplicação'
    };
    this.Lang_FR = {
    _200: 'Application'
    };
  
    this.getActive = function(){
        return $Lang.getActive();
    };
    
    if (this.getActive() === 'EN') this.L = this.Lang_EN;
    if (this.getActive() === 'ES') this.L = this.Lang_ES;
    if (this.getActive() === 'CZ') this.L = this.Lang_CZ;
    if (this.getActive() === 'PT') this.L = this.Lang_PT;
    if (this.getActive() === 'FR') this.L = this.Lang_FR;

    
    this.show = [true, false, false, false, false, false];
    this.showHideAll = function(){
        this.show = [false, false, false, false, false, false];
    };
    this.setShow = function(value){
        this.showHideAll();
        this.show[value] = true;
    };
})

.controller('labController', function($Settings, $LogFunctions, $Format, $Lang, $state) {
    

    this.arr = "\u2192";
    
    this.Lang_EN = {};
    this.Lang_ES = {};
    this.Lang_CZ = {};
    this.Lang_PT = {};
    this.Lang_FR = {};
    
    this.Lang_EN = {
        _11: 'Logic variable',
        _12: 'Logic operator',
        _13: 'Logic function',
        _14: 'Flip flop (async.)',
        _15: 'Flip flop (sync.)',
        _16: 'switch',
        _17: 'gate',
        _18: 'voltage',
        _19: 'logic gate',
        _20: 'input',
        _21: 'output',
        _22: 'truth table',
        _23: 'operators',
        _24: 'gates',
        _25: 'gates + LEDs',
        _26: 'truth tab.',
        _27: 'inclusive disjunction',
        _28: 'negation of inclusive disjunction',
        _29: 'logical conjunction',
        _30: 'negation of logical conjunction',
        _31: 'exclusive disjunction',
        _32: 'negation of exclusive disjunction',
        _33: 'all',
        _34: 'SR',
        _35: 'flip flop',
        _36: 'last',
        _37: 'reset',
        _38: 'to',
        _39: 'set',
        _40: 'indeterminate',
        _41: 'opposite',
        _42: 'synchronous',
        _43: '(async.)',
        _44: '(sync.)',
        _45: 'state',
        _46: '',
        _47: '',
        _48: '',
        _49: '',
        _50: 'Circuits (1) - (6)',
        _51: 'Circuits (7) - (12)',
        _52: 'Circuits (13) - (18)',
        _53: 'Circuits (19) - (24)',
        _54: '',
        _55: '',
        _56: '',
        _57: '',
        _58: '',
        _59: '',
        _60: 'Logic gate, waveforms',
        _61: '',
        _62: '',
        _63: '',
        _64: '',
        _65: '',
        _66: '',
        _67: '',
        _68: '',
        _69: '',
        _70: 'Boolean algebra',
        _71: "De Morgan's laws",
        _72: 'Commutative Law',
        _73: 'Associative Law',
        _74: 'Distributive Law',
        _75: 'Idempotent Law',
        _76: 'Complement Law',
        _77: 'Double Negation Law',
        _78: 'Absorptive Law',
        _79: 'Absorptive Law (negation)',
        _80: 'Annulment and Identity Law',
        _81: '',
        _82: '',
        _83: '',
        _84: '',
        _85: '',
        _86: '',
        _87: '',
        _88: '',
        _89: '',
        _90: '',
        _91: '',
        _92: '',
        _93: '',
        _94: '',
        _95: '',
        _96: ''
        
        
        
        

    
    
    
    
    };
    this.Lang_ES = {
        _11: 'Variable lógica',
        _12: 'Operador lógico',
        _13: 'Función lógica',
        _14: 'Flip flop biestable (asínc.)',
        _15: 'Flip flop biestable (sínc.)',
        _16: 'interruptor',
        _17: 'puerta lóg.',
        _18: 'voltaje',
        _19: 'puerta lógica',
        _20: 'entrada',
        _21: 'salida',
        _22: 'tabla de verdad',
        _23: 'operadores',
        _24: 'puertas',
        _25: 'puertas + LEDs',
        _26: 'tab. de verd.',
        _27: 'disyunción inclusiva',
        _28: 'negación de disyunción inclusiva',
        _29: 'conjunción lógica',
        _30: 'negación de conjunción lógica',
        _31: 'disyunción exclusiva',
        _32: 'negación de disyunción exclusiva',
        _33: 'todos',
        _34: 'SR',
        _35: 'flip flop',
        _36: 'último',
        _37: 'restablecer',
        _38: 'a',
        _39: 'establecer',
        _40: 'indeterminado',
        _41: 'opuesto',
        _42: 'síncrono',
        _43: '(asínc.)',
        _44: '(sínc.)',
        _45: 'estado',
        _46: '',
        _47: '',
        _48: '',
        _49: '',
        _50: 'Circuitos (1) - (6)',
        _51: 'Circuitos (7) - (12)',
        _52: 'Circuitos (13) - (18)',
        _53: 'Circuitos (19) - (24)',
        _54: '',
        _55: '',
        _56: '',
        _57: '',
        _58: '',
        _59: '',
        _60: 'Puerta lógica, formas de onda',
        _61: '',
        _62: '',
        _63: '',
        _64: '',
        _65: '',
        _66: '',
        _67: '',
        _68: '',
        _69: '',
        _70: 'Álgebra de Boole',
        _71: 'Leyes de De Morgan',
        _72: 'La ley conmutativa',
        _73: 'La ley asociativa',
        _74: 'Ley distributiva',
        _75: 'Ley de idempotencia',
        _76: 'Ley del complemento',
        _77: 'Ley de involución',
        _78: 'Ley de absorción',
        _79: 'Ley de absorción (negación)',
        _80: 'Ley de absorción e identidad',
        _81: '',
        _82: '',
        _83: '',
        _84: '',
        _85: '',
        _86: '',
        _87: '',
        _88: '',
        _89: '',
        _90: '',
        _91: '',
        _92: '',
        _93: '',
        _94: '',
        _95: '',
        _96: ''
    
    
    };    
    this.Lang_CZ = {
        _11: 'Logická proměnná',
        _12: 'Logický operátor',
        _13: 'Logická funkce',
        _14: 'Klopný obvod (asynchr.)',
        _15: 'Klopný obvod (synchr.)',
        _16: 'spínač',
        _17: 'hradlo',
        _18: 'napětí',
        _19: 'hradlo (log. člen)',
        _20: 'vstup',
        _21: 'výstup',
        _22: 'pravdivostní tabulka',
        _23: 'operátory',
        _24: 'hradla',
        _25: 'hradla + LED',
        _26: 'pravd. tab.',
        _27: 'logický součet',
        _28: 'negace log. součtu',
        _29: 'logický součin',
        _30: 'negace log. součinu',
        _31: 'exkluzivní logický součet',
        _32: 'negace exkluzivního log. součtu',
        _33: 'všechny',
        _34: 'RS',
        _35: 'klopný obvod',
        _36: 'minulý',
        _37: 'nastavit',
        _38: 'do',
        _39: 'nastavit',
        _40: 'neurčitý',
        _41: 'opačný',
        _42: 'synchronní',
        _43: '(asynchr.)',
        _44: '(synchr.)',
        _45: 'stav',
        _46: '',
        _47: '',
        _48: '',
        _49: '',
        _50: 'Obvody (1) - (6)',
        _51: 'Obvody (7) - (12)',
        _52: 'Obvody (13) - (18)',
        _53: 'Obvody (19) - (24)',
        _54: '',
        _55: '',
        _56: '',
        _57: '',
        _58: '',
        _59: '',
        _60: 'Logické hradlo, časové průběhy',
        _61: '',
        _62: '',
        _63: '',
        _64: '',
        _65: '',
        _66: '',
        _67: '',
        _68: '',
        _69: '',
        _70: 'Booleova algebra',
        _71: 'De Morganovy zákony',
        _72: 'Zákon komutativní',
        _73: 'Zákon asociativní',
        _74: 'Zákon distributivní',
        _75: 'Zákon idempotentní',
        _76: 'Zákon doplňku',
        _77: 'Zákon dvojité negace (involuce)',
        _78: 'Zákon absporpce',
        _79: 'Zákon absporpce negace',
        _80: 'Zákon neutrálnosti a agresivity',
        _81: '',
        _82: '',
        _83: '',
        _84: '',
        _85: '',
        _86: '',
        _87: '',
        _88: '',
        _89: '',
        _90: '',
        _91: '',
        _92: '',
        _93: '',
        _94: '',
        _95: '',
        _96: ''
    
    
    };    
    
    this.Lang_PT = {
        _11: 'Variável lógica',
        _12: 'Operador de lógica',
        _13: 'Função lógica',
        _14: 'Flip-flop (assínc.)',
        _15: 'Flip-flop (sínc.)',
        _16: 'interruptor',
        _17: 'porta',
        _18: 'tensão',
        _19: 'porta lógica',
        _20: 'entrada',
        _21: 'saída',
        _22: 'tabela verdade',
        _23: 'operadores',
        _24: 'portas',
        _25: 'portas + LED',
        _26: 'tab. verd.',
        _27: 'disjunção inclusiva',
        _28: 'negação de disjunção incl.',
        _29: 'conjunção lógica',
        _30: 'negação de conjunção lóg.',
        _31: 'disjunção exclusiva',
        _32: 'negação de disjunção excl.',
        _33: 'todos',
        _34: 'SR',
        _35: 'flip-flop',
        _36: 'último',
        _37: 'ajustar',
        _38: 'a',
        _39: 'ajustar',
        _40: 'indeterminado',
        _41: 'oposto',
        _42: 'síncrono',
        _43: '(assínc.)',
        _44: '(sínc.)',
        _45: 'estado',
        _46: '',
        _47: '',
        _48: '',
        _49: '',
        _50: 'Circuitos (1) - (6)',
        _51: 'Circuitos (7) - (12)',
        _52: 'Circuitos (13) - (18)',
        _53: 'Circuitos (19) - (24)',
        _54: '',
        _55: '',
        _56: '',
        _57: '',
        _58: '',
        _59: '',
        _60: 'Porta lógica, formas de onda',
        _61: '',
        _62: '',
        _63: '',
        _64: '',
        _65: '',
        _66: '',
        _67: '',
        _68: '',
        _69: '',
        _70: 'Álgebra booleana',
        _71: 'Leis de De Morgan',
        _72: 'Lei comutativa',
        _73: 'Lei associativa',
        _74: 'Lei distributiva',
        _75: 'Lei idempotente',
        _76: 'Lei complemento',
        _77: 'Lei de dupla negação',
        _78: 'Lei de absorção',
        _79: 'Lei de absorção (negação)',
        _80: 'Lei de anulação e identidade',
        _81: '',
        _82: '',
        _83: '',
        _84: '',
        _85: '',
        _86: '',
        _87: '',
        _88: '',
        _89: '',
        _90: '',
        _91: '',
        _92: '',
        _93: '',
        _94: '',
        _95: '',
        _96: ''
    
    
    };

    this.Lang_FR = {
        _11: 'Variable logique',
        _12: 'Opérateur logique',
        _13: 'Fonction logique',
        _14: 'Bascule Flip flop (asyn.)',
        _15: 'Bascule Flip flop (syn.)',
        _16: 'interrupteur',
        _17: 'porte',
        _18: 'tension',
        _19: 'porte logique',
        _20: 'entré',
        _21: 'sortie',
        _22: 'table de vérité',
        _23: 'opérateurs',
        _24: 'portes',
        _25: 'portes + LEDs',
        _26: 'table de vérifé',
        _27: 'disjonction inclusive',
        _28: 'négation d\'une disjonction inclusive',
        _29: 'conjonction logique',
        _30: 'négation d\'une conjonction logique',
        _31: 'disjonction exclusive',
        _32: 'négation d\'une disjonction exclusive',
        _33: 'tout',
        _34: 'SR',
        _35: 'bascule flip flop',
        _36: 'dernier',
        _37: 'réinitialiser',
        _38: 'jusque',
        _39: 'ajuster',
        _40: 'indéterminé',
        _41: 'opposé',
        _42: 'synchronisé',
        _43: '(async.)',
        _44: '(sync.)',
        _45: 'état',
        _46: '',
        _47: '',
        _48: '',
        _49: '',
        _50: 'Circuit (1) - (6)',
        _51: 'Circuit (7) - (12)',
        _52: 'Circuit (13) - (18)',
        _53: 'Circuit (19) - (24)',
        _54: '',
        _55: '',
        _56: '',
        _57: '',
        _58: '',
        _59: '',
        _60: 'Porte logique, formes d\'onde',
        _61: '',
        _62: '',
        _63: '',
        _64: '',
        _65: '',
        _66: '',
        _67: '',
        _68: '',
        _69: '',
        _70: 'Algèbre de Boole',
        _71: "Lois de De Morgan",
        _72: 'Loi commutative',
        _73: 'Loi associative',
        _74: 'Loi de distribution',
        _75: 'Loi d\'idempotence',
        _76: 'Loi complèmentaire',
        _77: 'Loi de double négation',
        _78: 'Loi d\'absorption',
        _79: 'Loi d\'absorption (négation)',
        _80: 'Loi d\'annulation et Loi d\'identité',
        _81: '',
        _82: '',
        _83: '',
        _84: '',
        _85: '',
        _86: '',
        _87: '',
        _88: '',
        _89: '',
        _90: '',
        _91: '',
        _92: '',
        _93: '',
        _94: '',
        _95: '',
        _96: ''
        
        
        
        

    
    
    
    
    };
    
    
    this.L = {};
    
    this.getActive = function(){
        return $Lang.getActive();
    };
    
    if (this.getActive() === 'EN') this.L = this.Lang_EN;
    if (this.getActive() === 'ES') this.L = this.Lang_ES;
    if (this.getActive() === 'CZ') this.L = this.Lang_CZ;
    if (this.getActive() === 'PT') this.L = this.Lang_PT;
    if (this.getActive() === 'FR') this.L = this.Lang_FR;
    
    this.getActive = function(){
        return $Lang.getActive();
    };
    this.setActive = function(value){
        $Lang.setActive(value);
    if (this.getActive() === 'EN') this.L = this.Lang_EN;
    if (this.getActive() === 'ES') this.L = this.Lang_ES;
    if (this.getActive() === 'CZ') this.L = this.Lang_CZ;
    if (this.getActive() === 'PT') this.L = this.Lang_PT;    
    if (this.getActive() === 'FR') this.L = this.Lang_FR;    

    };
    
//    this.L = this.Lang_CZ;
    
    this.data = $Settings.data;
  
    this.show = [true, false, false, false, false, false];
    this.showHideAll = function(){
        this.show = [false, false, false, false, false, false];
    };
    this.setShow = function(value){
        this.showHideAll();
        this.show[value] = true;
    };
   
    this.showVoltage = [true, false, false];
    this.showVoltageHideAll = function(){
        this.showVoltage = [false, false, false];
    };
    this.setShowVoltage = function(value){
        this.showVoltageHideAll();
        this.showVoltage[value] = true;
    };
    
    this.Zoom = function(){
        return $Settings.settings.app.getZoom();
    };
    
    this.getToggleA = function(){
        return $Settings.get.A();
    };
    
    this.getToggleB = function(){
        return $Settings.get.B();
    };
    
    this.getToggleC = function(){
        return $Settings.get.C();
    };
    
    this.setToggleA = function(value){
        $Settings.data.A = value;
    };
    this.setToggleB = function(value){
        $Settings.data.B = value;
    };
    this.setToggleC = function(value){
        $Settings.data.C = value;
    };
    
    
    
    
    this.background = function(){
        return $Settings.settings.app.getBackgroundTabLab();;
    };
//    this.background = $Settings.settings.app.getBackgroundTabLab();

    
    this.HighLow = function(){
        return $Settings.settings.app.getHighLow();
    };
    
    this.strLog = function(value){
        if (this.HighLow() === 'H, L') return (value ? 'H': 'L');
        if (this.HighLow() === 'T, F') return (value ? 'T': 'F');
        if (this.HighLow() === '1, 0') return (value ? '1': '0');
    };
    
    this.strLogF = function(){
        return $Settings.settings.app.LogFunction;
    };
    
    this.strLog_SR_Q = function(S, R){
        return $Format.strLog_SR_Q(S, R);
    };
    
    
    this.logOR_2 = function(A, B){
        return $LogFunctions.logOR_2(A, B);
    };
    this.logNOR_2 = function(A, B){
        return $LogFunctions.logNOR_2(A, B);
    };
    this.logAND_2 = function(A, B){
        return $LogFunctions.logAND_2(A, B);
    };
    this.logNAND_2 = function(A, B){
        return $LogFunctions.logNAND_2(A, B);
    };
    this.logXOR_2 = function(A, B){
        return $LogFunctions.logXOR_2(A, B);
    };
    this.logXNOR_2 = function(A, B){
        return $LogFunctions.logXNOR_2(A, B);
    };    
    
    
    
    this.logOR_3 = function(A, B, C){
        return $LogFunctions.logOR_3(A, B, C);
    };
    this.logAND_3 = function(A, B, C){
        return $LogFunctions.logAND_3(A, B, C);
    };
    
    
    this._A = function(value){
        return Math.floor(value/2);
    };
    this._B = function(value){
        return (value % 2);
    };
    
    
    this.TimeSignal = function(){
        return $Settings.settings.app.getTimeSignal();
    };
    
    
    this.logArrOrA = [];
    this.logArrOrB = [];
    this.logArrOrF = [];
    
    this.nextTimeOr = function(){
        this.logArrOrA.push(this.data.A);
        if (this.logArrOrA.length == 14){this.logArrOrA.splice(0, 1);};
        this.logArrOrB.push(this.data.B);
        if (this.logArrOrB.length == 14){this.logArrOrB.splice(0, 1);};
        
        this.logArrOrF.push($LogFunctions.logOR_2(this.data.A, this.data.B));
        if (this.logArrOrF.length == 14){this.logArrOrF.splice(0, 1);};
    };
    
    this.logArrNorA = [];
    this.logArrNorB = [];
    this.logArrNorF = [];
    
    this.nextTimeNor = function(){
        this.logArrNorA.push(this.data.A);
        if (this.logArrNorA.length == 14){this.logArrNorA.splice(0, 1);};
        this.logArrNorB.push(this.data.B);
        if (this.logArrNorB.length == 14){this.logArrNorB.splice(0, 1);};
        
        this.logArrNorF.push($LogFunctions.logNOR_2(this.data.A, this.data.B));
        if (this.logArrNorF.length == 14){this.logArrNorF.splice(0, 1);};
    };
    
    this.logArrAndA = [];
    this.logArrAndB = [];
    this.logArrAndF = [];
    
    this.nextTimeAnd = function(){
        this.logArrAndA.push(this.data.A);
        if (this.logArrAndA.length == 14){this.logArrAndA.splice(0, 1);};
        this.logArrAndB.push(this.data.B);
        if (this.logArrAndB.length == 14){this.logArrAndB.splice(0, 1);};
        
        this.logArrAndF.push($LogFunctions.logAND_2(this.data.A, this.data.B));
        if (this.logArrAndF.length == 14){this.logArrAndF.splice(0, 1);};
    };
    
    this.logArrNandA = [];
    this.logArrNandB = [];
    this.logArrNandF = [];
    
    this.nextTimeNand = function(){
        this.logArrNandA.push(this.data.A);
        if (this.logArrNandA.length == 14){this.logArrNandA.splice(0, 1);};
        this.logArrNandB.push(this.data.B);
        if (this.logArrNandB.length == 14){this.logArrNandB.splice(0, 1);};
        
        this.logArrNandF.push($LogFunctions.logNAND_2(this.data.A, this.data.B));
        if (this.logArrNandF.length == 14){this.logArrNandF.splice(0, 1);};
    };
    
    this.logArrXorA = [];
    this.logArrXorB = [];
    this.logArrXorF = [];
    
    this.nextTimeXor = function(){
        this.logArrXorA.push(this.data.A);
        if (this.logArrXorA.length == 14){this.logArrXorA.splice(0, 1);};
        this.logArrXorB.push(this.data.B);
        if (this.logArrXorB.length == 14){this.logArrXorB.splice(0, 1);};
        
        this.logArrXorF.push($LogFunctions.logXOR_2(this.data.A, this.data.B));
        if (this.logArrXorF.length == 14){this.logArrXorF.splice(0, 1);};
    };
    
    this.logArrXnorA = [];
    this.logArrXnorB = [];
    this.logArrXnorF = [];
    
    this.nextTimeXnor = function(){
        this.logArrXnorA.push(this.data.A);
        if (this.logArrXnorA.length == 14){this.logArrXnorA.splice(0, 1);};
        this.logArrXnorB.push(this.data.B);
        if (this.logArrXnorB.length == 14){this.logArrXnorB.splice(0, 1);};
        
        this.logArrXnorF.push($LogFunctions.logXNOR_2(this.data.A, this.data.B));
        if (this.logArrXnorF.length == 14){this.logArrXnorF.splice(0, 1);};
    }; 
    
})




;
