angular.module('starter.services', [])


.factory('$Lang', function(){
    var Lang = {};
    
    Lang.active = 'EN';
    Lang.getActive = function(){
        return Lang.active;
    };
    Lang.setActive = function(value){
        Lang.active = value;
        $state.go('tab-lab');
    };
    
    return Lang;
})

.factory('$Format', function($Settings, $LogFunctions){
    
    var Format = {};
    
    Format.strLog = function(value){
        if ($Settings.settings.app.getHighLow() === 'H, L') return (value ? 'H': 'L');
        if ($Settings.settings.app.getHighLow() === 'T, F') return (value ? 'T': 'F');
        if ($Settings.settings.app.getHighLow() === '1, 0') return (value ? '1': '0');
    };
    
//    Format.strLog_JK_Q = function(J, K, nowQ){
//        if (J && K) return Format.strLog(!nowQ);
//        return Format.strLog(LogFunctions.logJK_Q(J, K, last));
//    
//    };
    
    Format.strLog_JK_Q = function(J, K, nowQ){
        return Format.strLog($LogFunctions.logJK_Q(J, K, nowQ));
    };
    
    Format.strLog_SR_Q = function(S, R, last){
        if (S && R) return '?';
        return Format.strLog($LogFunctions.logSR_Q(S, R, last));
    };
    Format.strLog_SR_negQ = function(S, R, last){
        if (S && R) return '?';
        return Format.strLog(!$LogFunctions.logSR_Q(S, R, last));
    };
    
    return Format;
    

})

.factory('$LogFunctions', function(){

    var LogFunctions = {};
    
    LogFunctions.logJK_Q = function(A, B, nowQ){
        var neg = !nowQ;
        if (!A && !B) return nowQ;
        if (A && !B) return true;
        if (B && !A) return false;
        if (A && B) return (!nowQ);
    };
    
    LogFunctions.logSR_Q = function(A, B, last){
        if (!A && !B) return last;
        if (A) return A;
        if (B) return !B;
        return false;
    };
    LogFunctions.logSR_negQ = function(A, B, last){
        if (!A && !B) return !last;
        return !LogFunctions.logSR_Q(A, B, last);
    };
    
    LogFunctions.logOR_2 = function(A, B){
        return (A || B);
    };
    LogFunctions.logNOR_2 = function(A, B){
        return !LogFunctions.logOR_2(A, B);
    };
    
    LogFunctions.logAND_2 = function(A, B){
        return (A && B);
    };
    LogFunctions.logNAND_2 = function(A, B){
        return !LogFunctions.logAND_2(A, B);
    };
    
    LogFunctions.logXOR_2 = function(A, B){
        return(A !== B);
    };
    
    LogFunctions.logXNOR_2 = function(A, B){
        return !LogFunctions.logXOR_2(A, B);
    };
    
    
    LogFunctions.logOR_3 = function(A, B, C){
        return (A || B || C);
    };    
    
    LogFunctions.logAND_3 = function(A, B, C){
        return (A && B && C);
    };
    
    
    
    
    
    return LogFunctions;

})

.factory('$Settings', function(){
    
    var factory = {};
    factory.data = {};
    factory.data.A = false;
    factory.data.B = false;
    factory.data.C = false;
    
    factory.get = {};
    factory.get.A = function(){
        return factory.data.A;
    };
    factory.get.B = function(){
        return factory.data.B;
    };
    factory.get.C = function(){
        return factory.data.C;
    };
    
    factory.set = {};
    factory.set.A = function(value){
        factory.data.A = value;
    };
    factory.set.B = function(value){
        factory.data.B = value;
    };
    factory.set.C = function(value){
        factory.data.C = value;
    };
    
    
    factory.settings = {};
    factory.settings.app = {};
    factory.settings.app.backgroundTabLab = 'white';
    factory.settings.app.backgroundTabSettings = 'white';
    factory.settings.app.backgroundTabApp = 'white';
    
    factory.settings.app.setBackgroundTabLab = function(value){
        factory.settings.app.backgroundTabLab = value;
    };
    factory.settings.app.setBackgroundTabSet = function(value){
        factory.settings.app.backgroundTabSettings= value;
    };
    factory.settings.app.setBackgroundTabApp = function(value){
        factory.settings.app.backgroundTabApp= value;
    };    
    
    factory.settings.app.getBackgroundTabLab = function(){
        return factory.settings.app.backgroundTabLab;
    };
    factory.settings.app.getBackgroundTabSet = function(){
        return factory.settings.app.backgroundTabSettings;
    }; 
    factory.settings.app.getBackgroundTabApp = function(){
        return factory.settings.app.backgroundTabApp;
    };
    
    
    factory.settings.app.HighLow = '1, 0';
    factory.settings.app.setHighLow = function(value){
        factory.settings.app.HighLow = value;
    };
    factory.settings.app.getHighLow = function(){
        return factory.settings.app.HighLow;
    };
    
    
    factory.settings.app.LogFunction = 'F';
    factory.settings.app.setLogFunction = function(value){
        factory.settings.app.LogFunction = value;
    };
    factory.settings.app.getLogFunction = function(){
        return factory.settings.app.LogFunction;
    };   
    
    factory.settings.app.Zoom = 100;
    factory.settings.app.setZoom = function(value){
        factory.settings.app.Zoom = value;
    };
    factory.settings.app.getZoom = function(){
        return factory.settings.app.Zoom;
    };
    
    factory.settings.app.TimeSignal = 'T';
    factory.settings.app.setTimeSignal = function(value){
        factory.settings.app.TimeSignal = value;
    };
    factory.settings.app.getTimeSignal = function(){
        return factory.settings.app.TimeSignal;
    };
    
    return factory;
    
    
/*    
    return {
        getToggleA: function(){        
            return toggles.A;
        },
        getToggleB: function(){
            return toggles.B;
        },
        getToggleC: function(){
            return toggles.C;
        },
        setToggleA: function(value){
            toggles.A = value;
        },
        setToggleB: function(value){
            toggles.B = value;
        },
        setToggleC: function(value){
            toggles.C = value;
        }
    }
    
*/    
    
})

